#ifndef __FULL_HPP
#define __FULL_HPP

//enum StateType{VANISHING, TANGIBLE};

class FullState : public Access {
public:

  /*  FullState() : Access() {
  }
  virtual ~FullState() {}*/

  /*
protected:
  static int trans;
  static int *enabled, *priority;
  static TransType *transitionType;

  long primaryKey, secondaryKey;
  StateType type;
  #ifdef SAFE
  int magic;
  #endif

  int numberEnabled;
  FastDynaArray<int> *enabledTrans;

  int kids;
  FastDynaArray<StateMatrixElement> children;
  */
public:
  /*
#ifdef STATE_COUNT
  static long instances, destroyed;
#endif

  FullState() {
    #ifdef VERBOSE
    cout << "FullState (" << this << "): default constructor\n";
    #endif
    kids = 0;
    enabledTrans = new FastDynaArray<int>(8);
#ifdef STATE_COUNT
    instances++;
#endif
    #ifdef SAFE
    primaryKey = secondaryKey = UNDEFINED;
    magic = 1973;
    #endif
  }

  ~FullState() {
    #ifdef VERBOSE
    cout << "FullState (" << this << "): destructor\n";
    #endif
    #ifdef SAFE
    assert(magic==1973);
    magic = 0;
    #endif
    delete enabledTrans;
#ifdef STATE_COUNT
    destroyed++;
#endif
  }

  inline void computeHashKeys() {
    calcHashKeys(primaryKey, secondaryKey); 
  }
  #ifdef SAFE
  inline int getMagic() const { return magic; }
  #endif
  inline StateType getType() const { return type; }
  inline long getPrimaryKey() const { return primaryKey; }
  inline long getSecondaryKey() const { return secondaryKey; }
  int findEnabledTransitions();
  int getEnabledTransition(int t) { return (*enabledTrans)(t); }
  inline void fireEnabledTransition(int t, Access *next) const { 
    fire((*enabledTrans)(t), next);
  }
  inline int numberChildren() const { return kids; }
  inline int getNumberEnabled() const { return numberEnabled; }
  inline void setKids(int _kids) { kids = _kids; }
  inline double getEnabledTransWeight(int t) const { return
    getTransWeight((*enabledTrans)(t)); }
  inline StateMatrixElement &getChild(int t) const { 
    return children(t);
  }
  inline double rateOut() {
    double sum = 0;
    for (int n=0; n<kids; n++)
      sum += children(n).getWeight();
    return sum;
  }
  //  inline complex<double> markov(complex<double> s) {
  //    return rateOut()/(rateOut() + s);
  //  }

  inline double average(int n) {
    double result = 0.0;
    complex<double> delta_s(1e-06,1e-06);//0.00000001;
    complex<double> r1 = sojournTime(n, delta_s);
    //    complex<double> r2 = sojournTime(n, 0);
    complex<double> r2 = sojournTime(n, -delta_s);
    //    result = (r1 - r2).real()/delta_s;
    result = ((r1-r2)/(2.0*delta_s)).real();
    //    cout << "average result = " << -result << endl;

    return -result;
  }

  inline double getTotalTransWeight() const {
    double sum = 0;
    for (int t=0; t<getNumberEnabled(); t++)
      sum += getEnabledTransWeight(t);
    // if (sum != 1.0) cout << "SUM != 0" << endl;
    return sum;
  }

  inline void setChild(int t, long value, double weight) {
    if (weight <= 0) {
      cout << "warning: transition number " << (*enabledTrans)(t) << " (in order of declaration) fires with" << endl << "         non-positive rate " << weight << " in state:" << endl << "         ";
      output();
      cout << endl;
      return;
    }
    for (long n=0; n<kids; n++) {
      if (children(n).getDestination()==value) {
//        cout << "here we are... " << value << " is same destination\n";
//        cout << "extant weight is " << children(n).getWeight() << endl;
//        cout << "more weight is " << weight << endl;
//        cout << "final weight is " << children(n).getWeight()+weight << endl;
        children[n].setWeight(children(n).getWeight()+weight);
///        cout << "confirm: " << children(n).getWeight() << endl;
        return;
      }
    }
    children.check(kids);
    children[kids].setDestination(value);
    children[kids].setWeight(weight);
    kids++;
  }

  inline int matrixOutput(FILE *mf) {
    fwrite(&kids, sizeof(int), 1, mf);
    return fwrite(children.getArray(), sizeof(StateMatrixElement), kids, mf);
  }

  inline void calculateCountMeasures(double *measures) const {
    computeCountMeasures(enabledTrans->getArray(),
      numberEnabled, measures);
  }
  */
/*
inline int findEnabledTransitions() {
  register int numberEnabled = 0, vanishing = 0, t;
  enabledTrans.setLength(4);
  type = TANGIBLE;
  isEnabled(enabled);
  for (t=0; t<trans; t++) {
    switch(transitionType[t]) {
    case TIMED:
      if (!vanishing && enabled[t]) {
        enabledTrans.check(numberEnabled);
        enabledTrans[numberEnabled] = t;
        numberEnabled++;
      }
      break;
    case INSTANTANEOUS:
      if (enabled[t]) {
        if (!vanishing) {
          type = VANISHING;
          numberEnabled = 0;
          vanishing = 1;
        }
        enabledTrans.check(numberEnabled);
        enabledTrans[numberEnabled] = t;
        numberEnabled++;
        break;
      }
    }
  }
  enabledTrans.setLength(numberEnabled);
  return numberEnabled;
}
*/
  /*
  int initialise(int, TransType *,int *);
  */
};

#endif

